/**
 * Script to add achievements in-game. Player who reaches first XX points wins.
 */

/// load current game
map.file = "<attach>"

/// short description to be shown in finance window
/// and in standard implementation of get_about_text
scenario.short_description = "Tool Mark and Build Stops"
scenario.author = "Yona-TYT"
scenario.version = "2.0"
scenario.translation  <- "Yona-TYT"

const save_version = 1

desc_st_pass <- array(100)
desc_st_mail <- array(100)
//desc_st_good <- array(100)

total_st_pass <- 0
total_st_mail <- 0
//total_st_good <- 0

st_pass_text <- ""
st_mail_text <- ""
//st_good_text <- ""


c_st_list <- array(1000)
all_mark_point <- 0

selec_city <- null
city_name <- "Click in Townhall"


function get_info_text(pl)
{
	local info = ttextfile("info.txt")
	local text = ""
	
	if(selec_city)
    	info.tool = "<em>-> </em><a href='script:script_text("+pl+")'>"+ translate("[Clik Here] Stops Mark")+"</a>, Current City: <em>"+city_name+"</em>"
	else
		info.tool = "<em>-> </em> Selec a New City: <em>"+city_name+"</em>"

	info.pass = st_pass_text
	info.mail = st_mail_text
	//info.good = st_good_text

	return info.tostring()
}
function get_rule_text(pl)
{
	local rule = ttextfile("rule.txt")

	return rule.tostring()
}

function get_result_text(pl)
{
	local result = ttextfile("result.txt")

	return result.tostring()
}
function get_goal_text(pl)
{
	local goal = ttextfile("goal.txt")   

	return goal.tostring()
}

function is_scenario_completed(pl)
{
	return 1
}

function is_work_allowed_here(pl, tool_id, pos)
{
    local result
    local t = tile_x(pos.x, pos.y, pos.z)
	local build = t.find_object(mo_building)
	
	if (build && build.is_townhall()){
		selec_city = build.get_city()
		city_name  = ""+selec_city.get_name()+" --> "+selec_city.get_pos().href("("+selec_city.get_pos().tostring()+")")+""

	}
	return result
}

function start()
{
	get_stations_lists()
	preload_text_script()
	//region_start() //Para las regiones
}

function is_tool_allowed(pl, tool_id, wt)
{
	return true
}

function resume_game()
{
	get_stations_lists()
	preload_text_script()
    //region_resume_game() //regions Funtion
}

function mark_waypoint(pl, c_start, c_end, cov, text, wt, dptype)
{
	local nr = 0
	for (local j = c_start.x ;j<=c_end.x;j++){
		for (local i = c_start.y;i<=c_end.y;i++){	
			local c = coord(j,i)
			local coora = coord(j-(cov), i-(cov))
			local coorb = coord(j+(cov), i+(cov))
			for (local j = coora.x ;j<=coorb.x;j++){
				for (local i = coora.y;i<=coorb.y;i++){
                    local t = tile_x(j,i,0)
					local build = t.find_object(mo_building)
                    local way = t.find_object(mo_way)
					if (way && (way.is_marked() || build)){
						c = coord(j,i)                       
                    }
				}
			}
			local tile = tile_x(c.x, c.y, 0)

			local way = tile.find_object(mo_way)
			local slope = tile.get_slope()
			local depot = tile.find_object(dptype)
			local build = tile.find_object(mo_building)

			if (!build && way && !way.is_marked() && slope==0 && !depot){
				if (way.get_waytype()!=wt)
					continue

				local ribi = way.get_dirs()
				if ((ribi==1)||(ribi==2)||(ribi==4)||(ribi==8)||(ribi==10)||(ribi==5)){
					way.mark()
					c_st_list[nr] = square_x(c.x,c.y).get_ground_tile()
					nr++
					all_mark_point = nr
					i+=4
					if (i>c_end.y) j++
				}
                continue
			}	
		}
	}
		
	preload_text_script()
	return null
}

function script_text(pl)
{

	if(selec_city){
	    //Marca las posiciones para las paradas
		local start = selec_city.get_pos_nw()	//coord(115,58)
		local end = selec_city.get_pos_se()		//coord(140,78)
		local cov = 4
		local text = translate("Place Stop here!.")
		local wt = wt_road
		local dptype = mo_depot_road
   		mark_waypoint(pl, start, end, cov, text, wt, dptype)
	}
    return null
}

function script_text_pass(nr)
{
	if (all_mark_point == 0){
		reset_values()
		return null
	}
	
	for(local j = 0;j<all_mark_point;j++){
		command_x.build_station (player_x(0), c_st_list[j], desc_st_pass[nr], dir.all)
		c_st_list[j].find_object(mo_way).unmark()
	}
	reset_values()
	return null
}

function script_text_mail(nr)
{
	if (all_mark_point == 0){
		reset_values()
		return null
	}
	
	for(local j = 0;j<all_mark_point;j++){
		command_x.build_station (player_x(0), c_st_list[j], desc_st_mail[nr], dir.all)
		c_st_list[j].find_object(mo_way).unmark()
	}
	reset_values()	
	return null
}

/*function script_text_good(nr)
{
	if (all_mark_point == 0)
		return null
	
	for(local j = 0;j<all_mark_point;j++){
		command_x.build_station (player_x(0), c_st_list[j], desc_st_good[nr], dir.all)
		c_st_list[j].find_object(mo_way).unmark()
	}	
	reset_values()
	return null
}*/

function preload_text_script()
{
	st_pass_text = ""
	for(local j = 0; j<total_st_pass;j++){
		local name = "[Clik Here] " + translate(desc_st_pass[j].get_name())
		local cost = desc_st_pass[j].get_cost()*(-1)
		local t_cost = (desc_st_pass[j].get_cost()*all_mark_point)*(-1)
		local text = translate("Cost")+" = <st>"+cost+"</st> c/u], [" + translate("Gasto Total") + " = <st>"+t_cost+"</st>]"
		st_pass_text +=  "<em>["+(j+1)+"]</em> <a href='script:script_text_pass("+j+")'>"+name+"</a> <br>--> ["+text+"<br><br>"
	}

	st_mail_text = ""
	for(local j = 0; j<total_st_mail;j++){
		local name = "[Clik Here] " + translate(desc_st_mail[j].get_name())
		local cost = desc_st_mail[j].get_cost()*(-1)
		local t_cost = (desc_st_mail[j].get_cost()*all_mark_point)*(-1)
		local text = translate("Cost")+" = <st>"+cost+"</st> c/u], [" + translate("Gasto Total") + " = <st>"+t_cost+"</st>]"
		st_mail_text +=  "<em>["+(j+1)+"]</em> <a href='script:script_text_mail("+j+")'>"+name+"</a> <br>--> ["+text+"<br><br>"
	}

	/*st_good_text = ""
	for(local j = 0; j<total_st_good;j++){
		local name = translate(desc_st_good[j].get_name())
		local cost = desc_st_good[j].get_cost()*(-1)
		local t_cost = (desc_st_good[j].get_cost()*all_mark_point)*(-1)
		local text = translate("Cost")+" = <st>"+cost+"</st> c/u], [" + translate("Gasto Total") + " = <st>"+t_cost+"</st>]"
		st_good_text +=  "<em>["+(j+1)+"]</em> <a href='script:script_text_good("+j+")'>"+name+"</a> <br>--> ["+text+"<br><br>"
	}*/
}

function reset_values()
{
	c_st_list = array(1000)
	all_mark_point = 0
	selec_city = null
	city_name = "Click in Townhall"
}

function get_stations_lists()
{
	local pass_d = good_desc_x("")	// Pass desc index 0
	local mail_d = good_desc_x("")	// Mail desc index 1
	//local good_d = good_desc_x("")	// Good desc index 2

	local good_list = good_desc_list_x()
	foreach(good_desc in good_list) {
		if (good_desc.get_catg_index() == 0)
			pass_d = good_desc
		if (good_desc.get_catg_index() == 1)
			mail_d = good_desc
		//if (good_desc.get_catg_index() == 2)
			//good_d = good_desc
	}

	local time = world.get_time()
	local time_line = world.use_timeline()

	local st_list_pass = building_desc_x.get_available_stations(building_desc_x.station, wt_road, pass_d)
	local st_list_mail = building_desc_x.get_available_stations(building_desc_x.station, wt_road, mail_d)
	//local st_list_good = building_desc_x.get_available_stations(building_desc_x.station, wt_road, good_d)
    local name = ""

	local nr = 0
	foreach(st in st_list_pass){
		if (!time_line){
			desc_st_pass[nr] = st
			nr++
		}
		else if(st.is_available(time)){
			desc_st_pass[nr] = st
			nr++
		}
	}
	total_st_pass = nr

	nr = 0
	foreach(st in st_list_mail){
		if (!time_line){
			desc_st_mail[nr] = st
			nr++
		}
		else if(st.is_available(time)){
			desc_st_mail[nr] = st
			nr++
		}
	}
	total_st_mail = nr

	/*nr = 0
	foreach(st in st_list_good){
		if (!time_line){
			desc_st_good[nr] = st
			nr++
		}
		else if(st.is_available(time)){
			desc_st_good[nr] = st
			nr++
		}
	}
	total_st_good = nr*/
}
